// Generated by CoffeeScript 1.10.0
(function() {
  var formats, fs, r;

  r = require('restructure');

  fs = require('fs');

  formats = [];

  exports.registerFormat = function(format) {
    formats.push(format);
    return exports[format.name] = format;
  };

  exports.openSync = function(filename, postscriptName) {
    var buffer;
    buffer = fs.readFileSync(filename);
    return exports.create(buffer, postscriptName);
  };

  exports.open = function(filename, postscriptName, callback) {
    if (typeof postscriptName === 'function') {
      callback = postscriptName;
      postscriptName = null;
    }
    fs.readFile(filename, function(err, buffer) {
      var e, error, font;
      if (err) {
        return callback(err);
      }
      try {
        font = exports.create(buffer, postscriptName);
      } catch (error) {
        e = error;
        return callback(e);
      }
      return callback(null, font);
    });
  };

  exports.create = function(buffer, postscriptName) {
    var font, format, i, len;
    for (i = 0, len = formats.length; i < len; i++) {
      format = formats[i];
      if (format.probe(buffer)) {
        font = new format(new r.DecodeStream(buffer));
        if (postscriptName) {
          return font.getFont(postscriptName);
        }
        return font;
      }
    }
    throw new Error('Unknown font format');
  };

}).call(this);
