// Generated by CoffeeScript 1.10.0
(function() {
  var AATLookupTable;

  AATLookupTable = (function() {
    function AATLookupTable(table) {
      this.table = table;
    }

    AATLookupTable.prototype.lookup = function(glyph) {
      var max, mid, min, seg;
      switch (this.table.version) {
        case 0:
          return this.table.values.getItem(glyph);
        case 2:
        case 4:
          min = 0;
          max = this.table.binarySearchHeader.nUnits - 1;
          while (min <= max) {
            mid = (min + max) >> 1;
            seg = this.table.segments[mid];
            if (seg.firstGlyph === 0xffff) {
              return null;
            }
            if (glyph < seg.firstGlyph) {
              max = mid - 1;
            } else if (glyph > seg.lastGlyph) {
              min = mid + 1;
            } else {
              if (this.table.version === 2) {
                return seg.value;
              } else {
                return seg.values[glyph - seg.firstGlyph];
              }
            }
          }
          break;
        case 6:
          min = 0;
          max = this.table.binarySearchHeader.nUnits - 1;
          while (min <= max) {
            mid = (min + max) >> 1;
            seg = this.table.segments[mid];
            if (seg.glyph === 0xffff) {
              return null;
            }
            if (glyph < seg.glyph) {
              max = mid - 1;
            } else if (glyph > seg.glyph) {
              min = mid + 1;
            } else {
              return seg.value;
            }
          }
          break;
        case 8:
          return this.table.values[glyph - this.table.firstGlyph];
        default:
          throw new Error("Unknown lookup table format: " + this.table.version);
      }
      return null;
    };

    return AATLookupTable;

  })();

  module.exports = AATLookupTable;

}).call(this);
