// Generated by CoffeeScript 1.10.0
(function() {
  var AATLayoutEngine, GlyphRun, KernProcessor, LayoutEngine, OTLayoutEngine, Script, UnicodeLayoutEngine, unicode,
    indexOf = [].indexOf || function(item) { for (var i = 0, l = this.length; i < l; i++) { if (i in this && this[i] === item) return i; } return -1; };

  KernProcessor = require('./KernProcessor');

  UnicodeLayoutEngine = require('./UnicodeLayoutEngine');

  GlyphRun = require('./GlyphRun');

  Script = require('./Script');

  unicode = require('unicode-properties');

  AATLayoutEngine = require('../aat/AATLayoutEngine');

  OTLayoutEngine = require('../opentype/OTLayoutEngine');

  LayoutEngine = (function() {
    var GlyphPosition;

    function LayoutEngine(font) {
      this.font = font;
      this.engine = this.font.morx ? new AATLayoutEngine(this.font) : this.font.GSUB || this.font.GPOS ? new OTLayoutEngine(this.font) : void 0;
    }

    LayoutEngine.prototype.layout = function(string, features, script, language) {
      var codePoints, glyph, glyphs, j, len, positions, ref, ref1;
      if (features == null) {
        features = [];
      }
      if (typeof features === 'string') {
        script = features;
        language = script;
        features = [];
      }
      if (typeof string === 'string') {
        if (script == null) {
          script = Script.forString(string);
        }
        glyphs = this.font.glyphsForString(string);
      } else {
        if (script == null) {
          codePoints = [];
          for (j = 0, len = string.length; j < len; j++) {
            glyph = string[j];
            codePoints.push.apply(codePoints, glyph.codePoints);
          }
          script = Script.forCodePoints(codePoints);
        }
        glyphs = string;
      }
      if (glyphs.length === 0) {
        return new GlyphRun(glyphs, []);
      }
      if ((ref = this.engine) != null) {
        if (typeof ref.setup === "function") {
          ref.setup(glyphs, features, script, language);
        }
      }
      glyphs = this.substitute(glyphs, features, script, language);
      positions = this.position(glyphs, features, script, language);
      if ((ref1 = this.engine) != null) {
        if (typeof ref1.cleanup === "function") {
          ref1.cleanup();
        }
      }
      return new GlyphRun(glyphs, positions);
    };

    LayoutEngine.prototype.substitute = function(glyphs, features, script, language) {
      var ref;
      if ((ref = this.engine) != null ? ref.substitute : void 0) {
        glyphs = this.engine.substitute(glyphs, features, script, language);
      }
      return glyphs;
    };

    GlyphPosition = (function() {
      function GlyphPosition(xAdvance, yAdvance, xOffset, yOffset) {
        this.xAdvance = xAdvance != null ? xAdvance : 0;
        this.yAdvance = yAdvance != null ? yAdvance : 0;
        this.xOffset = xOffset != null ? xOffset : 0;
        this.yOffset = yOffset != null ? yOffset : 0;
      }

      return GlyphPosition;

    })();

    LayoutEngine.prototype.position = function(glyphs, features, script, language) {
      var glyph, i, j, len, positioned, positions, ref;
      positions = [];
      for (i = j = 0, len = glyphs.length; j < len; i = ++j) {
        glyph = glyphs[i];
        positions.push(new GlyphPosition(glyph.advanceWidth));
      }
      positioned = (ref = this.engine) != null ? typeof ref.position === "function" ? ref.position(glyphs, positions, features, script, language) : void 0 : void 0;
      if (!positioned) {
        if (this.unicodeLayoutEngine == null) {
          this.unicodeLayoutEngine = new UnicodeLayoutEngine(this.font);
        }
        this.unicodeLayoutEngine.positionGlyphs(glyphs, positions);
      }
      if (!(positioned != null ? positioned.kern : void 0) && this.font.kern) {
        if (this.kernProcessor == null) {
          this.kernProcessor = new KernProcessor(this.font);
        }
        this.kernProcessor.process(glyphs, positions);
      }
      return positions;
    };

    LayoutEngine.prototype.getAvailableFeatures = function(script, language) {
      var features;
      features = [];
      if (this.engine) {
        features.push.apply(features, this.engine.getAvailableFeatures(script, language));
      }
      if (this.font.kern && indexOf.call(features, 'kern') < 0) {
        features.push('kern');
      }
      return features;
    };

    return LayoutEngine;

  })();

  module.exports = LayoutEngine;

}).call(this);
