// Generated by CoffeeScript 1.10.0
(function() {
  var RTL, UNICODE_SCRIPTS, unicode;

  unicode = require('unicode-properties');

  UNICODE_SCRIPTS = {
    Caucasian_Albanian: 'aghb',
    Arabic: 'arab',
    Imperial_Aramaic: 'armi',
    Armenian: 'armn',
    Avestan: 'avst',
    Balinese: 'bali',
    Bamum: 'bamu',
    Bassa_Vah: 'bass',
    Batak: 'batk',
    Bengali: ['bng2', 'beng'],
    Bopomofo: 'bopo',
    Brahmi: 'brah',
    Braille: 'brai',
    Buginese: 'bugi',
    Buhid: 'buhd',
    Chakma: 'cakm',
    Canadian_Aboriginal: 'cans',
    Carian: 'cari',
    Cham: 'cham',
    Cherokee: 'cher',
    Coptic: 'copt',
    Cypriot: 'cprt',
    Cyrillic: 'cyrl',
    Devanagari: ['dev2', 'deva'],
    Deseret: 'dsrt',
    Duployan: 'dupl',
    Egyptian_Hieroglyphs: 'egyp',
    Elbasan: 'elba',
    Ethiopic: 'ethi',
    Georgian: 'geor',
    Glagolitic: 'glag',
    Gothic: 'goth',
    Grantha: 'gran',
    Greek: 'grek',
    Gujarati: ['gjr2', 'gujr'],
    Gurmukhi: ['gur2', 'guru'],
    Hangul: 'hang',
    Han: 'hani',
    Hanunoo: 'hano',
    Hebrew: 'hebr',
    Hiragana: 'hira',
    Pahawh_Hmong: 'hmng',
    Katakana_Or_Hiragana: 'hrkt',
    Old_Italic: 'ital',
    Javanese: 'java',
    Kayah_Li: 'kali',
    Katakana: 'kana',
    Kharoshthi: 'khar',
    Khmer: 'khmr',
    Khojki: 'khoj',
    Kannada: ['knd2', 'knda'],
    Kaithi: 'kthi',
    Tai_Tham: 'lana',
    Lao: 'lao ',
    Latin: 'latn',
    Lepcha: 'lepc',
    Limbu: 'limb',
    Linear_A: 'lina',
    Linear_B: 'linb',
    Lisu: 'lisu',
    Lycian: 'lyci',
    Lydian: 'lydi',
    Mahajani: 'mahj',
    Mandaic: 'mand',
    Manichaean: 'mani',
    Mende_Kikakui: 'mend',
    Meroitic_Cursive: 'merc',
    Meroitic_Hieroglyphs: 'mero',
    Malayalam: ['mlm2', 'mlym'],
    Modi: 'modi',
    Mongolian: 'mong',
    Mro: 'mroo',
    Meetei_Mayek: 'mtei',
    Myanmar: ['mym2', 'mymr'],
    Old_North_Arabian: 'narb',
    Nabataean: 'nbat',
    Nko: 'nko ',
    Ogham: 'ogam',
    Ol_Chiki: 'olck',
    Old_Turkic: 'orkh',
    Oriya: 'orya',
    Osmanya: 'osma',
    Palmyrene: 'palm',
    Pau_Cin_Hau: 'pauc',
    Old_Permic: 'perm',
    Phags_Pa: 'phag',
    Inscriptional_Pahlavi: 'phli',
    Psalter_Pahlavi: 'phlp',
    Phoenician: 'phnx',
    Miao: 'plrd',
    Inscriptional_Parthian: 'prti',
    Rejang: 'rjng',
    Runic: 'runr',
    Samaritan: 'samr',
    Old_South_Arabian: 'sarb',
    Saurashtra: 'saur',
    Shavian: 'shaw',
    Sharada: 'shrd',
    Siddham: 'sidd',
    Khudawadi: 'sind',
    Sinhala: 'sinh',
    Sora_Sompeng: 'sora',
    Sundanese: 'sund',
    Syloti_Nagri: 'sylo',
    Syriac: 'syrc',
    Tagbanwa: 'tagb',
    Syloti_Nagri: 'takr',
    Tai_Le: 'tale',
    New_Tai_Lue: 'talu',
    Tamil: 'taml',
    Tai_Viet: 'tavt',
    Telugu: ['tel2', 'telu'],
    Tifinagh: 'tfng',
    Tagalog: 'tglg',
    Thaana: 'thaa',
    Thai: 'thai',
    Tibetan: 'tibt',
    Tirhuta: 'tirh',
    Ugaritic: 'ugar',
    Vai: 'vai ',
    Warang_Citi: 'wara',
    Old_Persian: 'xpeo',
    Cuneiform: 'xsux',
    Yi: 'yi  ',
    Inherited: 'zinh',
    Common: 'zyyy',
    Unknown: 'zzzz'
  };

  exports.fromUnicode = function(script) {
    return UNICODE_SCRIPTS[script];
  };

  exports.forString = function(string) {
    var code, idx, len, next, script;
    len = string.length;
    idx = 0;
    while (idx < len) {
      code = string.charCodeAt(idx++);
      if ((0xd800 <= code && code <= 0xdbff) && idx < len) {
        next = string.charCodeAt(idx);
        if ((0xdc00 <= next && next <= 0xdfff)) {
          idx++;
          code = ((code & 0x3FF) << 10) + (next & 0x3FF) + 0x10000;
        }
      }
      script = unicode.getScript(code);
      if (script !== 'Common' && script !== 'Inherited' && script !== 'Unknown') {
        return UNICODE_SCRIPTS[script];
      }
    }
    return UNICODE_SCRIPTS.Unknown;
  };

  exports.forCodePoints = function(codePoints) {
    var codePoint, i, len1, script;
    for (i = 0, len1 = codePoints.length; i < len1; i++) {
      codePoint = codePoints[i];
      script = unicode.getScript(codePoint);
      if (script !== 'Common' && script !== 'Inherited' && script !== 'Unknown') {
        return UNICODE_SCRIPTS[script];
      }
    }
    return UNICODE_SCRIPTS.Unknown;
  };

  RTL = {
    arab: true,
    hebr: true,
    syrc: true,
    thaa: true,
    cprt: true,
    khar: true,
    phnx: true,
    'nko ': true,
    lydi: true,
    avst: true,
    armi: true,
    phli: true,
    prti: true,
    sarb: true,
    orkh: true,
    samr: true,
    mand: true,
    merc: true,
    mero: true,
    mani: true,
    mend: true,
    nbat: true,
    narb: true,
    palm: true,
    phlp: true
  };

  exports.direction = function(script) {
    if (RTL[script]) {
      return 'rtl';
    }
    return 'ltr';
  };

}).call(this);
