// Generated by CoffeeScript 1.10.0
(function() {
  var GPOSProcessor, GSUBProcessor, GlyphInfo, OTLayoutEngine, Shapers, ShapingPlan,
    slice = [].slice;

  ShapingPlan = require('./ShapingPlan');

  Shapers = require('./shapers');

  GlyphInfo = require('./GlyphInfo');

  GSUBProcessor = require('./GSUBProcessor');

  GPOSProcessor = require('./GPOSProcessor');

  OTLayoutEngine = (function() {
    function OTLayoutEngine(font) {
      this.font = font;
      if (this.font.GSUB) {
        this.GSUBProcessor = new GSUBProcessor(this.font, this.font.GSUB);
      }
      if (this.font.GPOS) {
        this.GPOSProcessor = new GPOSProcessor(this.font, this.font.GPOS);
      }
      this.glyphInfos = null;
      this.plan = null;
    }

    OTLayoutEngine.prototype.setup = function(glyphs, features, script, language) {
      var glyph, i, shaper;
      this.glyphInfos = (function() {
        var j, len, results;
        results = [];
        for (i = j = 0, len = glyphs.length; j < len; i = ++j) {
          glyph = glyphs[i];
          results.push(new GlyphInfo(glyph.id, slice.call(glyph.codePoints)));
        }
        return results;
      })();
      shaper = Shapers.choose(script);
      this.plan = new ShapingPlan(this.font, script, language);
      return shaper.plan(this.plan, this.glyphInfos, features);
    };

    OTLayoutEngine.prototype.substitute = function(glyphs) {
      var glyphInfo;
      if (this.GSUBProcessor) {
        this.plan.process(this.GSUBProcessor, this.glyphInfos);
        glyphs = (function() {
          var j, len, ref, results;
          ref = this.glyphInfos;
          results = [];
          for (j = 0, len = ref.length; j < len; j++) {
            glyphInfo = ref[j];
            results.push(this.font.getGlyph(glyphInfo.id, glyphInfo.codePoints));
          }
          return results;
        }).call(this);
      }
      return glyphs;
    };

    OTLayoutEngine.prototype.position = function(glyphs, positions) {
      var ref;
      if (this.GPOSProcessor) {
        this.plan.process(this.GPOSProcessor, this.glyphInfos, positions);
      }
      if (this.plan.direction === 'rtl') {
        glyphs.reverse();
        positions.reverse();
      }
      return (ref = this.GPOSProcessor) != null ? ref.features : void 0;
    };

    OTLayoutEngine.prototype.cleanup = function() {
      this.glyphInfos = null;
      return this.plan = null;
    };

    OTLayoutEngine.prototype.getAvailableFeatures = function(script, language) {
      var features;
      features = [];
      if (this.GSUBProcessor) {
        this.GSUBProcessor.selectScript(script, language);
        features.push.apply(features, Object.keys(this.GSUBProcessor.features));
      }
      if (this.GPOSProcessor) {
        this.GPOSProcessor.selectScript(script, language);
        features.push.apply(features, Object.keys(this.GPOSProcessor.features));
      }
      return features;
    };

    return OTLayoutEngine;

  })();

  module.exports = OTLayoutEngine;

}).call(this);
