// Generated by CoffeeScript 1.10.0
(function() {
  var COMMON_FEATURES, DIRECTIONAL_FEATURES, DefaultShaper, FRACTIONAL_FEATURES, HORIZONTAL_FEATURES, VERTICAL_FEATURES, unicode,
    slice = [].slice;

  unicode = require('unicode-properties');

  COMMON_FEATURES = ['ccmp', 'locl', 'rlig', 'mark', 'mkmk'];

  FRACTIONAL_FEATURES = ['frac', 'numr', 'dnom'];

  HORIZONTAL_FEATURES = ['calt', 'clig', 'liga', 'rclt', 'curs', 'kern'];

  VERTICAL_FEATURES = ['vert'];

  DIRECTIONAL_FEATURES = {
    ltr: ['ltra', 'ltrm'],
    rtl: ['rtla', 'rtlm']
  };

  DefaultShaper = (function() {
    function DefaultShaper() {}

    DefaultShaper.plan = function(plan, glyphs, features) {
      this.planPreprocessing(plan);
      this.planFeatures(plan);
      this.planPostprocessing(plan, features);
      plan.assignGlobalFeatures(glyphs);
      return this.assignFeatures(plan, glyphs);
    };

    DefaultShaper.planPreprocessing = function(plan) {
      return plan.add({
        global: DIRECTIONAL_FEATURES[plan.direction],
        local: FRACTIONAL_FEATURES
      });
    };

    DefaultShaper.planFeatures = function(plan) {};

    DefaultShaper.planPostprocessing = function(plan, userFeatures) {
      return plan.add(slice.call(COMMON_FEATURES).concat(slice.call(HORIZONTAL_FEATURES), slice.call(userFeatures)));
    };

    DefaultShaper.assignFeatures = function(plan, glyphs) {
      var end, glyph, i, start;
      i = 0;
      while (i < glyphs.length) {
        glyph = glyphs[i];
        if (glyph.codePoints[0] === 0x2044) {
          start = i - 1;
          end = i + 1;
          while (start >= 0 && unicode.isDigit(glyphs[start].codePoints[0])) {
            glyphs[start].features.numr = true;
            glyphs[start].features.frac = true;
            start--;
          }
          while (end < glyphs.length && unicode.isDigit(glyphs[end].codePoints[0])) {
            glyphs[end].features.dnom = true;
            glyphs[end].features.frac = true;
            end++;
          }
          glyph.features.frac = true;
          i = end - 1;
        } else {
          i++;
        }
      }
    };

    return DefaultShaper;

  })();

  module.exports = DefaultShaper;

}).call(this);
